//---------------------------------------------------------------------------

#include <fmx.h>
#pragma hdrstop

#include "uMain.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.fmx"
TMain *Main;
bool g_MyfnStop = false;
typedef String __fastcall (*pThxfn)(String);
//---------------------------------------------------------------------------
__fastcall TMain::TMain(TComponent* Owner)
  : TForm(Owner)
{
  m_DoneEvent = OnDoneEvent;
  m_Done = OnDone;
}
//---------------------------------------------------------------------------
String __fastcall Myfn(String aStr)
{
  Sleep(aStr.ToInt());
  return "Myfn";
}
//---------------------------------------------------------------------------
String __fastcall Thxfn(String aStr)
{
  Sleep(aStr.ToInt());
  return "Thxfn";
}
//---------------------------------------------------------------------------
String __fastcall Delfn(String aStr)
{
  Sleep(aStr.ToInt());
  return "Delfn";
}
//---------------------------------------------------------------------------

void __fastcall fnDone(String aResult)
{
  Main->Memo1->Lines->Add(Format("fnDone: %s delegate has finished", ARRAYOFCONST((aResult))));

  if (g_MyfnStop == false) {
    if (aResult == "Myfn") {
      new TMyDelegate(Myfn, Main->DoneEvent, "30");
    }
    else if (aResult == "Delfn") {
      fnDelegate<pThxfn, TDone, String>(Delfn, Main->Done, "1");
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TMain::OnDone(String aResult)
{
  _di_TThreadProcedure methProc;
  Memo1->Lines->Add(Format("OnDone: %s delegate has finished", ARRAYOFCONST((aResult))));

  if (g_MyfnStop == false) {
    if (aResult == "Myfn") {
      new TMyDelegate(Myfn, fnDone, "200");
    }
    else if (aResult == "Thxfn") {
      methProc = dynamic_cast<TThreadProcedure*>(new TThxDelegate<pThxfn, pfnDone>(Thxfn, fnDone, "500"));
      TThread::Queue(NULL, methProc);
    }
    else if (aResult == "Delfn") {
      fnDelegate<pThxfn, pfnDone, String>(Delfn, fnDone, "100");
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TMain::OnDoneEvent(TObject *Sender, String aResult)
{
  Memo1->Lines->Add(Format("OnDoneEvent: %s delegate has finished", ARRAYOFCONST((aResult))));
  if (g_MyfnStop == false) {
    new TMyDelegate(Myfn, OnDone, "10");
  }
}
//---------------------------------------------------------------------------
void __fastcall TMain::Image1Click(TObject *Sender)
{
  Memo1->Lines->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TMain::Button1Click(TObject *Sender)
{
  TButton *btn = Button1;

  g_MyfnStop = btn->Tag;
  if (btn->Tag == false) {
    btn->Text = "myfn Stop !!!";
    new TMyDelegate(Myfn, OnDoneEvent, "1");
  }
  else {
    btn->Text = "myfn Go !!!";
  }
  btn->Tag = !btn->Tag;
}
//---------------------------------------------------------------------------
void __fastcall TMain::Button2Click(TObject *Sender)
{
  TButton *btn = Button2;
  _di_TThreadProcedure methProc;

  g_MyfnStop = btn->Tag;
  if (btn->Tag == false) {
    btn->Text = "thxfn Stop !!!";
    methProc = dynamic_cast<TThreadProcedure*>(new TThxDelegate<pThxfn, TDone>(Thxfn, OnDone, "1000"));
    TThread::Queue(NULL, methProc);
  }
  else {
    btn->Text = "thxfn Go !!!";
  }
  btn->Tag = !btn->Tag;
}
//---------------------------------------------------------------------------
void __fastcall TMain::Button3Click(TObject *Sender)
{
  TButton *btn = Button3;

  g_MyfnStop = btn->Tag;
  if (btn->Tag == false) {
    btn->Text = "delefn Stop !!!";
    fnDelegate<pThxfn, TDone, String>(Delfn, OnDone, "1");
  }
  else {
    btn->Text = "delefn Go !!!";
  }
  btn->Tag = !btn->Tag;
}
//---------------------------------------------------------------------------

