//---------------------------------------------------------------------------

#ifndef uMainH
#define uMainH
//---------------------------------------------------------------------------
#include "uFunctionDelegate.hpp"

#include <System.Classes.hpp>
#include <FMX.Controls.hpp>
#include <FMX.Forms.hpp>
#include <FMX.Controls.Presentation.hpp>
#include <FMX.StdCtrls.hpp>
#include <FMX.Types.hpp>
#include <FMX.Memo.hpp>
#include <FMX.ScrollBox.hpp>
#include <FMX.Layouts.hpp>
#include <FMX.Objects.hpp>
#include <FMX.TreeView.hpp>
#include <FMX.Dialogs.hpp>
//---------------------------------------------------------------------------

class TMain : public TForm
{
__published:	// IDE-managed Components
  TPanel *Panel1;
  TPanel *Panel3;
  TPanel *Panel4;
  TMemo *Memo1;
  TSplitter *Splitter1;
  TStatusBar *StatusBar1;
  TLabel *Label1;
  TPanel *Panel5;
  TImage *Image1;
  TButton *Button1;
  TButton *Button2;
  TButton *Button3;
  void __fastcall Image1Click(TObject *Sender);
   void __fastcall Button1Click(TObject *Sender);
  void __fastcall Button2Click(TObject *Sender);
  void __fastcall Button3Click(TObject *Sender);
private:	// User declarations
  TDoneEvent m_DoneEvent;
  TDone m_Done;
  void __fastcall OnDone(String aResult);
  void __fastcall OnDoneEvent(TObject *Sender, String aResult);


public:		// User declarations
  __fastcall TMain(TComponent* Owner);

  __property TDoneEvent DoneEvent = {read=m_DoneEvent, write=m_DoneEvent};
  __property TDone Done = {read=m_Done, write=m_Done};
};
//---------------------------------------------------------------------------
extern PACKAGE TMain *Main;
//---------------------------------------------------------------------------
#endif
